Unit Utility;

interface

{$IFDEF WINDOWS}
Uses WinDos,WinCrt,Strings;
{$ELSE}
Uses Dos,Crt,Strings;
{$ENDIF}

type      xfloat        = extended;                    {Premenna typu extended}

var       Scroll_Lock   : byte absolute $0000:$0417;
          Scroll        : byte absolute Scroll_Lock;   {4 bit do 1 rozsvieti Scroll Lock}
          Hodiny        : byte;
          Minuty        : byte;
          Sekundy       : byte;
          ExtRam        : pointer;                     {Ukazovatel na umiestnenia pola v alokovanej pamati, musi byt tam}
          ASCII_Biosu   : string absolute $F000:$FFF5; {kde je definovana procedura WriteRAM}
const     Base          = $60;

procedure GetVector(Cislo:byte;var Adresa:pointer);             {Zistim pozadovany vektor prerusenia}
procedure SetVector(Cislo:byte;Adresa:pointer);                 {Zmenim vektor prerusenia}
procedure Beep;                                                 {Zvukove znamenie}
procedure Zisti_Realny_Cas(var Hod,Min,Sek:byte);               {Procedura zisti realny cas v BCD}
procedure Aktualny_Cas(var Hod,Min,Sek:byte);                   {Procedura zisti realny cas v DEC}
procedure Vypis_Normovany_Cas;                                  {Vytvori specificky casovy retazec}
procedure Inc_Real(var X:xfloat;Y:xfloat);
procedure Dec_Real(var X:xfloat;Y:xfloat);
procedure Dec_Xfloat(var X:xfloat;Y:xfloat);
procedure Inc_Xfloat(var X:xfloat;Y:xfloat);
procedure Cakaj(Dlzka:longint);
procedure Zisti_Mod_Zobrazenia(var Cis_Modu,Video_Str:byte);
procedure Uspat_Klavesnicu(Retazec:char);
procedure Write_Ram(Adress:word;Data:byte);                     {Zapisem do alokovanej pamati}
procedure Vypis_Priamo_Na_Obrazovku(Retazec:string;Riadok,Stlpec,Farba,Pozadie:byte);   (*Priamo zapisem do VIDEORAM*)
function Konverzia(BCD:byte):byte;                              {Funkcia prevedie cislo na retazec}
function Lower(Source:string):string;                           {Funkcia prevedie vsetky pismena na male}
function Upper(Source:string):string;                           {Funkcia prevedie vsetky pismena na velke}
function Velkost_RAM:word;                                      {Zistim volnu kapacitu RAM}
function Total_RAM:word;                                        {Zistim velkost RAM}
function Prevod(Cislo:byte):string;                             {}
function Convert_Hex(Cislo:byte):string;                        {Prevedie cislo z 00Dec na 00Hex}
function Read_Ram(Adress:word):byte;                            {Precitam z alokovanej pamati}
function Max_Allocate:longint;                                  {Funkcia vrati velkost dostupnej pamati pre alokaciu}
function IntToHex(Cislo:word):string;                           {Prevedie z DEC do HEX}
function LongIntToHex(Cislo:longint):string;                    {Prevedie z DEC do HEX}
function HexToInt(Cislo:string):word;                           {Prevedie z HEX do DEC}
function BinToHex(Retazec:string):string;                       {Prevedie z BIN do HEX}
function Nahrad_Retazec(Povodny,Novy,Retazec:string):string;    {Nahradi retazec novym a vrati vysledok}
function Zisti_Cislo_Biosu:string;                              {Zistim idendifikacne cislo BIOSu}
function IntHex(Cislo:byte):string;
{function Vytvor_IntelHex(Retazec:string):string;                {Z retazca vytvori riadok vo formate IntelHex+CRC}

implementation

procedure Zisti_Realny_Cas(var Hod,Min,Sek:byte);
begin
     asm
        push ax                {Ulozim obsah registru na zasobnik}
        push dx                {Ulozim obsah registru na zasobnik}
        push di                {Ulozim obsah registru na zasobnik}
        push es                {Ulozim obsah registru na zasobnik}
        mov ah,02h             {Funkcia 02h DOSu na zistenie realneho casu}
        int 1ah                {Vyvolam prerusenie}
        cld                    {Incrementalny smer spracovania retazcov}
        les di,ss:[Hod]        {Segmentova adresa do ES a offsetova do DI daneho objektu}
        mov al,ch              {CH hodiny, CL minuty, DH sekundy v BCD}
        stosb                  {Vysledok ulozim na adresu danu ES:DI}
        les di,ss:[Min]        {Segmentova adresa do ES a offsetova do DI daneho objektu}
        mov al,cl
        stosb                  {Vysledok ulozim na adresu danu ES:DI}
        les di,ss:[Sek]        {Segmentova adresa do ES a offsetova do DI daneho objektu}
        mov al,dh
        stosb                  {Vysledok ulozim na adresu danu ES:DI}
        pop es                 {Obnovim register hodnotou zo zasobnika}
        pop di                 {Obnovim register hodnotou zo zasobnika}
        pop dx                 {Obnovim register hodnotou zo zasobnika}
        pop ax                 {Obnovim register hodnotou zo zasobnika}
     end;
end;

function Konverzia(BCD:byte):byte;
var   Pomocna : byte;
      Jed,Des : word;
const Z_16    : word = $10;
      Z_10    : word = $0A;
begin
     asm
        push ax                         {Register AX odlozim na zasobnik}
        push cx                         {Register AX odlozim na zasobnik}
        push dx                         {Register AX odlozim na zasobnik}
        push es                         {Register AX odlozim na zasobnik}
        push ds                         {Register AX odlozim na zasobnik}
        pop es                          {Register ES=DS}
        xor cx,cx                       {Musia byt nulove, inac INT 00h}
        xor dx,dx                       {Musia byt nulove, inac INT 00h}
        mov al,byte ptr ss:[BCD]        {Do AL ulozime BCD cislo}
        cbw                             {Konverzia na typ word}
        cmp ax,0009h                    {Porovnam AX s 09h}
        jle @Kon                        {Je mensie alebo rovne tak skoc ...}
        cmp ax,word ptr ss:[Z_16]       {Porovnaj AS s 10h}
        jz @Skok                        {Je 10h, aby nebolo INT 00h}
        div word ptr ss:[Z_16]          {Vydelime AX/10h}
        mov word ptr ss:[Des],ax        {Do premennej Des obsah registra AX}
        mov word ptr ss:[Jed],dx        {Do premennej Jed obsah registra DX}
        mul word ptr ss:[Z_10]          {Nasobime AX*0Ah}
        add ax,word ptr ss:[Jed]        {Scitame register AX+[Jed]}
        jmp near ptr [@Kon]             {Ukoncim vypocet}
@Skok:  mov al,0ah                      {Vratim 0Ah, lebo je to 10}
@Kon:   mov byte ptr ss:[Pomocna],al    {Vratim ....}
        pop es                          {Obnovim register ES hodnotou zo zasobnika}
        pop dx                          {Obnovim register DX hodnotou zo zasobnika}
        pop cx                          {Obnovim register CX hodnotou zo zasobnika}
        pop ax                          {Obnovim register AX hodnotou zo zasobnika}
     end;
     Konverzia:=Pomocna;
end;

function Konverzia_Na_Retazec(Cislo:byte):string;
var Pomocna : string[$02];
begin
     Str(Cislo,Pomocna);
     if Length(Pomocna)=$01 then Pomocna:='0'+Pomocna;
     Konverzia_Na_Retazec:=Pomocna;
end;

procedure Vypis_Normovany_Cas;
var Pomocna : string;
begin
     Pomocna:=Konverzia_Na_Retazec(Hodiny)+':'+Konverzia_Na_Retazec(Minuty)+':'+Konverzia_Na_Retazec(Sekundy);
     WriteLn(Pomocna);
end;

procedure Aktualny_Cas(var Hod,Min,Sek:byte);
begin
     Zisti_Realny_Cas(Hodiny,Minuty,Sekundy);
     Hod:=Konverzia(Hodiny);
     Min:=Konverzia(Minuty);
     Sek:=Konverzia(Sekundy);
end;

procedure Inc_Real(var X:xfloat;Y:xfloat);
begin
     X:=X+Y;
end;

procedure Dec_Real(var X:xfloat;Y:xfloat);
begin
     X:=X-Y;
end;

procedure Inc_Xfloat(var X:xfloat;Y:xfloat);
begin
     asm

     end;
end;

procedure Dec_Xfloat(var X:xfloat;Y:xfloat);
begin
     asm

     end;
end;

procedure Inicializacia; far; assembler;
asm
   push ax              {Odlozim register}
   mov al,10110110b     {10-Timer 2, 11-Citanie najprv nizsi byte potom vyssi, 011-Mod 3, 0-dekadicke citanie}
   out 43h,al           {Inicializujem zapisom na port 43h}
   pop ax               {Vytiahnem register}
end;

function Zisti_Timer:word; assembler;
asm
   push ax
   in al,42h            {Zistim nizsi byte casovaca a ulozim do AL}
   xchg al,ah           {Zamenim obsahy registrov}
   in al,42h            {Zistim vyssi byte casovaca a ulozim do AL}
   xchg al,ah           {Zamenim obsahy registrov}
   pop ax
end;

procedure Nastav_Timer(Data:word); assembler;
asm
   push ax
   mov ax,word ptr ss:[Data] {Buduci obsah citaca do AX}
   out 42h,al                {Nizsi byte na port 42h}
   xchg al,ah                {Vymenim AL a AH medzi sebou}
   out 42h,al                {Vyssi byte na port 42h}
   pop ax
end;

procedure Start_Timer; assembler;
asm
   push ax
   mov ah,00000011b     {do AH dame masku}
   in al,61h            {Precitame port 61h a vlozime do AL}
   or al,ah             {a nastavime dolne 2 bity na 1}
   out 61h,al           {a vysleme to na port 61h}
   pop ax
end;

procedure Koniec_Timer; assembler;
asm
   push ax              {Odlozim register}
   mov ah,11111100b     {Maska do AH}
   in al,61h            {Precitam z portu 61h a vlozim do AL}
   and al,ah            {Logicky sucin aby sme nastavili dolne 2 bity na nulu}
   out 61h,al           {a nastavene vyslem na port 61h}
   pop ax               {Vytiahnem register}
end;

{$IFDEF WINDOWS}
procedure Beep;
var i : longint;
begin
     i:=0;
     Inicializacia;
     Nastav_Timer($500);
     Start_Timer;
     Repeat
           Inc(i);
     Until i=500000;
     Koniec_Timer;
end;
{$ELSE}
procedure Beep;
begin
     Sound(1000);
     Delay(100);
     NoSound;
end;
{$ENDIF}

procedure Cakaj(Dlzka:longint);
begin
     asm
        push ax
        push cx
        push dx
        mov ah,86h                      {Funkcia DOSu spusti cakaci interval}
        mov cx,word ptr ss:[Dlzka+2]    {Dlzka cakania v mikrosekundach, vyssie slovo}
        mov dx,word ptr ss:[Dlzka]      {Dlzka cakania v mikrosekundach nizsie slovo}
        int 15h                         {Vyvolam prerusenie a ....}
        pop dx
        pop cx
        pop ax
     end;
end;

procedure GetVector(Cislo:byte;var Adresa:pointer);
begin
     asm
        push ax                         {Odkladam vsetky dolezite vektory}
        push bx
        mov ah,35h                      {Funkcia 35h na zistenie vektora prerusenia}
        mov al,byte ptr ss:[Cislo]      {Do registra AL cislo zistovaneho vektora}
        int 21h                         {Vyvolam vektor prerusenia}
        mov ax,bx                       {Do AX presuniem offset adresy zistovaneho vektora prerusenia}
        push es                         {Na zasobnik ulozim register ES so segmentom zistovaneho vektora prerusenia}
        les di,ss:[Adresa]              {Do ES teraz vlozime segment premennej Adresa_Prerusenia a DI naplnime offsetom}
        cld                             {Priznak smeru, inkrementalny}
        stosw                           {Obsah AX presuniem na adresu ES:DI}
        pop ax                          {Zo zasobnika ulozim do registra AX a je to obsah registra ES}
        stosw                           {Obsah AX presuniem na adresu ES:DI+2}
        pop bx
        pop ax                          {Obnovim vsetky registre}
     end;
end;

procedure SetVector(Cislo:byte;Adresa:pointer);
begin
     asm
        push ds                                     {Ulozim DS na zasobnik}
        mov ah,25h                                  {Funkcia DOSu na nastavenie vektorov prerusenia s adresou DS:DX}
        mov al,byte ptr ss:[Cislo]                  {Do Al ulozime cislo, ktore budeme nastavovat}
        mov ds,word ptr ss:[Adresa+2]               {Do DS segmentovu cast adresy}
        mov dx,word ptr ss:[Adresa]                 {Do DX offseotvu cast adresy}
        int 21h                                     {Vyvolam prerusenie a nastavim vektory}
        pop ds                                      {Obnovim obsah registra DS, prtoze som ho zmenil}
     end;
end;

procedure Zisti_Mod_Zobrazenia(var Cis_Modu,Video_Str:byte);
begin
     asm
        push ax
        push bx
        push es
        mov ah,0fh
        int 10h
        cld
        les di,ss:[Cis_Modu]
        stosb
        xchg al,bh
        les di,ss:[Video_Str]
        stosb
        pop es
        pop bx
        pop ax
     end;
end;

procedure Uspat_Klavesnicu(Retazec:char);
begin
     Case Retazec of
          'a','A','y','Y' : begin Port[Base]:=$F5; {$IFDEF WINDOWS} {$ELSE} Delay(100); {$ENDIF} end;
          'n','N'         : begin Port[Base]:=$F4; {$IFDEF WINDOWS} {$ELSE} Delay(100); {$ENDIF} end;
     end;
end;
{
function Lower(Source:string):string;
var Znak    : ^byte;
    i       : byte;
    AdrSeg  : word;
    AdrOfs  : word;
    Pomocna : string;
begin
     Pomocna:='';
     AdrSeg:=Seg(Source);
     AdrOfs:=Ofs(Source);
     for i:=1 to Length(Source) do
         begin
              Znak:=Ptr(AdrSeg,AdrOfs+i);
              case Chr(Znak^) of 'A'..'Z' : Znak^:=Znak^+$20; end;
              Pomocna:=Pomocna+Chr(Znak^);
         end;
     Lower:=Pomocna;
end;

function Upper(Source:string):string;
var Znak    : ^byte;
    i       : byte;
    AdrSeg  : word;
    AdrOfs  : word;
    Pomocna : string;
begin
     Pomocna:='';
     AdrSeg:=Seg(Source);
     AdrOfs:=Ofs(Source);
     for i:=1 to Length(Source) do
         begin
              Znak:=Ptr(AdrSeg,AdrOfs+i);
              case Chr(Znak^) of 'a'..'z' : Znak^:=Znak^-$20; end;
              Pomocna:=Pomocna+Chr(Znak^);
         end;
     Upper:=Pomocna;
end;
}

function Lower(Source:string):string;
var i        : byte;
    Znak     : ^byte;
    Pomocna  : string;
begin
     Pomocna:='';
     for i:=1 to Length(Source) do
     begin
          Znak:=Ptr(Seg(Source),Ofs(Source)+i);
          Case Chr(Znak^) of 'A'..'Z'  : Znak^:=Znak^+$20; end;
          Pomocna:=Pomocna+Chr(Znak^);
     end;
     Lower:=Pomocna;
end;

function Upper(Source:string):string;
var i        : byte;
    Znak     : ^byte;
    Pomocna  : string;
begin
     Pomocna:='';
     for i:=1 to Length(Source) do
     begin
          Znak:=Ptr(Seg(Source),Ofs(Source)+i);
          Case Chr(Znak^) of 'a'..'z'  : Znak^:=Znak^-$20; end;
          Pomocna:=Pomocna+Chr(Znak^);
     end;
     Upper:=Pomocna;
end;

function Velkost_RAM:word;
begin
     asm
        push ax
        int 12h
        mov @Result,ax
        pop ax
     end;
end;

function Total_RAM:word;
var Pomocna : word;
begin
     asm
        push ax
        push bx
        mov al,15h
        out 70h,al
        in al,71h
        mov bl,al
        mov al,16h
        out 70h,al
        in al,71h
        mov bh,al
        mov word ptr ss:[Pomocna],bx
        push bx
        push ax
     end;
     Total_RAM:=Pomocna;
end;

function Prevod(Cislo:byte):string;
var Retazec   : string[$01];
begin
     Case  Cislo of
          $00..$09 : Str(Cislo,Retazec);
          $0A      : Retazec:='A';
          $0B      : Retazec:='B';
          $0C      : Retazec:='C';
          $0D      : Retazec:='D';
          $0E      : Retazec:='E';
          $0F      : Retazec:='F';
     end;
     Prevod:=Retazec;
end;

function Convert_Hex(Cislo:byte):string;
var Retazec   : string[$05];
    Pole      : array [$00..$05] of byte;
    i         : byte;
begin
     Retazec:='';
     for i:=SizeOf(Cislo) downto $00 do
     begin
          Pole[i]:=Cislo mod $10;
          Cislo:=Cislo div $10;
     end;
     for i:=$00 to SizeOf(Cislo) do
         begin
              Retazec:=Retazec+Prevod(Pole[i]);
         end;
     Convert_Hex:=Retazec;
end;

procedure Write_Ram(Adress:word;Data:byte);     {Zapisem do alokovanej pamati}
begin
     Mem[(MemW[Seg(ExtRam):Ofs(ExtRam)+$02]):Adress]:=Data;
end;

function Read_Ram(Adress:word):byte;            {Precitam z alokovanej pamati}
begin
     Read_Ram:=Mem[(MemW[Seg(ExtRam):Ofs(ExtRam)+$02]):Adress];
end;

function Max_Allocate:longint;
begin
     Max_Allocate:=MaxAvail;                    {Kolko pamati mame dostupnej ???}
end;

function IntToHex(Cislo:word):string;
var H1,H2,H3,H4 : string[2];
function Prevod(Numero:word):string;
var Pomocna : string[2];
begin
     Pomocna:='';
     Case Numero of
          0..9 : begin Str(Numero,Pomocna); end;
          $0A  : begin Pomocna:='A' end;
          $0B  : begin Pomocna:='B' end;
          $0C  : begin Pomocna:='C' end;
          $0D  : begin Pomocna:='D' end;
          $0E  : begin Pomocna:='E' end;
          $0F  : begin Pomocna:='F' end;
     end;
     Prevod:=Pomocna;
end;
begin
     H1:=Prevod((Cislo div $1000)mod $10);
     H2:=Prevod((Cislo div $100)mod $10);
     H3:=Prevod((Cislo div $10)mod $10);
     H4:=Prevod(Cislo mod $10);
     IntToHex:=H1+H2+H3+H4;
end;

function LongIntToHex(Cislo:longint):string;
var H0,H1,H2,H3,H4,H5,H6 : string[2];
function Prevod(Numero:word):string;
var Pomocna : string[2];
begin
     Pomocna:='';
     Case Numero of
          0..9 : begin Str(Numero,Pomocna); end;
          $0A  : begin Pomocna:='A' end;
          $0B  : begin Pomocna:='B' end;
          $0C  : begin Pomocna:='C' end;
          $0D  : begin Pomocna:='D' end;
          $0E  : begin Pomocna:='E' end;
          $0F  : begin Pomocna:='F' end;
     end;
     Prevod:=Pomocna;
end;
begin
     H0:=Prevod((Cislo div $1000000)mod $10);
     H1:=Prevod((Cislo div $100000)mod $10);
     H2:=Prevod((Cislo div $10000)mod $10);
     H3:=Prevod((Cislo div $1000)mod $10);
     H4:=Prevod((Cislo div $100)mod $10);
     H5:=Prevod((Cislo div $10)mod $10);
     H6:=Prevod(Cislo mod $10);
     LongIntToHex:=H0+H1+H2+H3+H4+H5+H6;
end;

function HexToInt(Cislo:string):word;
var Numero : word;
    Count  : word;
begin
     While Pos(' ',Cislo)<>0 do
           begin
                Delete(Cislo,Pos(' ',Cislo),Length(' '));       {Vymazem prebytocne medzery}
           end;
     if Pos('h',Cislo)>0 then
        begin
             Delete(Cislo,Pos('h',Cislo),Length('h'));
             Insert('$',Cislo,Length('$'));
        end;
     if Pos('H',Cislo)>0 then
        begin
             Delete(Cislo,Pos('H',Cislo),Length('H'));
             Insert('$',Cislo,Length('$'));
        end;
     if (Pos('0x',Cislo)<>0) then
        begin
             Delete(Cislo,Pos('0x',Cislo),Length('0x'));        {Vymazem hexa zapis v C}
             Insert('$',Cislo,Length('$'));                     {Nahradim zapisom v TP a konvertujem na Dec}
        end;
     if (Pos('$',Cislo)<>0) then
        begin
             Val(Cislo,Numero,Count);
        end;
     HexToInt:=Numero;
end;

function BinToHex(Retazec:string):string;
var Pole       : array [0..15] of byte;
    Vysledok   : word;
    i          : word;
begin
     Vysledok:=0;
     While Pos(' ',Retazec)>0 do Delete(Retazec,Pos(' ',Retazec),Length(' '));
     if (Copy(Retazec,Length(Retazec),1)='b') or (Copy(Retazec,Length(Retazec),1)='B') then
        begin
             Delete(Retazec,Pos('b',Retazec),Length('b'));
             Delete(Retazec,Pos('B',Retazec),Length('B'));
             for i:=0 to Length(Retazec)-1 do
                 begin
                      if Copy(Retazec,Length(Retazec)-i,1)='1' then Pole[i]:=1 else Pole[i]:=0;
                      Vysledok:=Vysledok+Pole[i]*(1 shl i);
                 end;
        end;
     BinToHex:=IntToHex(Vysledok);
end;

function Nahrad_Retazec(Povodny,Novy,Retazec:string):string;
var Pozicia : byte;
begin
     while Pos(Povodny,Retazec)>0 do
           begin
                Pozicia:=Pos(Povodny,Retazec);
                Delete(Retazec,Pozicia,Length(Povodny));
                Insert(Novy,Retazec,Pozicia);
           end;
     Nahrad_Retazec:=Retazec;
end;

procedure Vypis_Priamo_Na_Obrazovku(Retazec:string;Riadok,Stlpec,Farba,Pozadie:byte);   (*Priamo zapisem do VIDEORAM*)
var i       : byte;
    Pozicia : ^byte;
begin
     if (Riadok in [1..25]) and (Stlpec in [1..80]) and (Farba in [0..15]) and (Pozadie in [0..15]) then
        begin
             for i:=0 to Length(Retazec)-1 do
                 begin
                      Pozicia:=Ptr($B800,((Riadok-1)*80*2)+((Stlpec-1)+i)*2);     (*Nastavim ukazovatel na zapis do Video RAM*)
                      Pozicia^:=Ord(char(Ptr(Seg(Retazec),Ofs(Retazec)+(i+1))^)); (*Priamo zapisem znak*)
                      Pozicia:=Ptr($B800,((Riadok-1)*80*2)+(((Stlpec-1)+i)*2)+1); (*Nastavim ukazovatel na zapis do Video RAM*)
                      Pozicia^:=(((Pozadie shl 4) and $F0) or Farba);             (*Priamo pisem farbu a pozadie do Video RAM*)
                 end;
        end;
end;

function Zisti_Cislo_Biosu:string;
var Retazec : string[8];
begin
     Retazec:=ASCII_Biosu;
     Zisti_Cislo_Biosu:=Retazec;
end;

function IntHex(Cislo:byte):string;
var H3,H4 : string[2];
function Prevod(Numero:byte):string;
var Pomocna : string[2];
begin
     Pomocna:='';
     Case Numero of
          0..9 : begin Str(Numero,Pomocna); end;
          $0A  : begin Pomocna:='A' end;
          $0B  : begin Pomocna:='B' end;
          $0C  : begin Pomocna:='C' end;
          $0D  : begin Pomocna:='D' end;
          $0E  : begin Pomocna:='E' end;
          $0F  : begin Pomocna:='F' end;
     end;
     Prevod:=Pomocna;
end;
begin
     H3:=Prevod((Cislo div $10)mod $10);
     H4:=Prevod(Cislo mod $10);
     if H3='0' then IntHex:=H4 else IntHex:=H3+H4;
end;

end.
